Loading...
Searching...
No Matches
pcl::CRHAlignment< PointT, nbins_ > Class Template Reference
Module recognition

CRHAlignment uses two Camera Roll Histograms (CRH) to find the roll rotation that aligns both views. More...

`#include <pcl/recognition/crh_alignment.h>`

## Public Member Functions

| CRHAlignment ()
| Constructor.
void | getTransforms (std::vector< Eigen::Matrix4f, Eigen::aligned_allocator< Eigen::Matrix4f > > &transforms)
| returns the computed transformations
void | setInputAndTargetView (PointTPtr &input_view, PointTPtr &target_view)
| sets model and input views
void | setInputAndTargetCentroids (Eigen::Vector3f &c1, Eigen::Vector3f &c2)
| sets model and input centroids
void | align (pcl::PointCloud< pcl::Histogram< nbins_ > > &input_ftt, pcl::PointCloud< pcl::Histogram< nbins_ > > &target_ftt)
| Computes the transformation aligning model to input.
void | computeRollAngle (pcl::PointCloud< pcl::Histogram< nbins_ > > &input_ftt, pcl::PointCloud< pcl::Histogram< nbins_ > > &target_ftt, std::vector< float > &peaks)
| Computes the roll angle that aligns input to model.

## Detailed Description

template<typename PointT, int nbins_>
class pcl::CRHAlignment< PointT, nbins_ >

CRHAlignment uses two Camera Roll Histograms (CRH) to find the roll rotation that aligns both views.

See:

- CAD-Model Recognition and 6 DOF Pose Estimation A. Aldoma, N. Blodow, D. Gossow, S. Gedikli, R.B. Rusu, M. Vincze and G. Bradski ICCV 2011, 3D Representation and Recognition (3dRR11) workshop Barcelona, Spain, (2011)

Author
  Aitor Aldoma

Definition at line 30 of file crh_alignment.h.

## Constructor & Destructor Documentation

## CRHAlignment()

template<typename PointT , int nbins_>

pcl::CRHAlignment< PointT, nbins_ >::CRHAlignment | ( |  | ) |

inline

Constructor.

Definition at line 106 of file crh_alignment.h.

## Member Function Documentation

## align()

template<typename PointT , int nbins_>

void pcl::CRHAlignment< PointT, nbins_ >::align | ( | pcl::PointCloud< pcl::Histogram< nbins_ > > & | input_ftt,
|  | pcl::PointCloud< pcl::Histogram< nbins_ > > & | target_ftt
| ) |  |

inline

Computes the transformation aligning model to input.

Parameters

  [in] | input_ftt | CRH histogram of the input cloud
  [in] | target_ftt | CRH histogram of the target cloud

Definition at line 146 of file crh_alignment.h.

## computeRollAngle()

template<typename PointT , int nbins_>

void pcl::CRHAlignment< PointT, nbins_ >::computeRollAngle | ( | pcl::PointCloud< pcl::Histogram< nbins_ > > & | input_ftt,
|  | pcl::PointCloud< pcl::Histogram< nbins_ > > & | target_ftt,
|  | std::vector< float > & | peaks
| ) |  |

inline

Computes the roll angle that aligns input to model.

Parameters

  [in] | input_ftt | CRH histogram of the input cloud
  [in] | target_ftt | CRH histogram of the target cloud
  [out] | peaks | Vector containing angles where the histograms correlate

Definition at line 184 of file crh_alignment.h.

References kiss_fft_cpx::i, and kiss_fft_cpx::r.

## getTransforms()

template<typename PointT , int nbins_>

void pcl::CRHAlignment< PointT, nbins_ >::getTransforms | ( | std::vector< Eigen::Matrix4f, Eigen::aligned_allocator< Eigen::Matrix4f > > & | transforms | ) |

inline

returns the computed transformations

Parameters

  [out] | transforms | transformations

Definition at line 115 of file crh_alignment.h.

## setInputAndTargetCentroids()

template<typename PointT , int nbins_>

void pcl::CRHAlignment< PointT, nbins_ >::setInputAndTargetCentroids | ( | Eigen::Vector3f & | c1,
|  | Eigen::Vector3f & | c2
| ) |  |

inline

sets model and input centroids

Parameters

  [in] | c1 | model view centroid
  [in] | c2 | input view centroid

Definition at line 135 of file crh_alignment.h.

## setInputAndTargetView()

template<typename PointT , int nbins_>

void pcl::CRHAlignment< PointT, nbins_ >::setInputAndTargetView | ( | PointTPtr & | input_view,
|  | PointTPtr & | target_view
| ) |  |

inline

sets model and input views

Parameters

  [in] | input_view |
  [in] | target_view |

Definition at line 124 of file crh_alignment.h.

The documentation for this class was generated from the following file:

- pcl/recognition/crh_alignment.h